=== debian/changelog ===
haxe (1:3.2.1+dfsg-1build1) xenial; urgency=medium

  * No-change rebuild for ncurses6 transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Feb 2016 15:53:13 +0000

haxe (1:3.2.1+dfsg-1) unstable; urgency=low

  * New upstream version.

 -- Andy Li <andy@onthewings.net>  Wed, 14 Oct 2015 10:42:48 +0800

haxe (1:3.2.0+dfsg-1) unstable; urgency=low

  * Adopt package (Closes: #799151).
    + Set maintainer to myself.
  * Set Vcs-* fields to Haxe Foundation haxe-debian git repo.
  * New upstream version.
    + Update neko version dependency.
  * Remove outdated and discontinued emacs haxe mode.
  * Clean up copyright.
    + Remove entries of removed files.
  * Update d/watch and get-orig-source target
    + Create tar manually to include git submodules.

 -- Andy Li <andy@onthewings.net>  Wed, 26 Aug 2015 15:01:06 +0800
