=== debian/watch ===
version=3
opts="dversionmangle=s/\+dfsg//,uversionmangle=s/-/~/g,repacksuffix=+dfsg"\
 https://github.com/HaxeFoundation/haxe/releases .*/(\d\S*)\.tar\.gz
