=== debian/changelog ===
haxe (1:3.4.0-1) unstable; urgency=low

  * New upstream version.
    + Depends on PCRE.
    + There is no bundled jQuery source file, thus, remove +dfsg tag.
    + Remove dependencies of libjs-jquery and libjs-swfobject.
    + Remove upstream applied patch.
    + Update d/copyright.
  * Update d/watch and get-orig-source target (no +dfsg).
  * Bump Standards-Version to 3.9.8 (no changes).

 -- Andy Li <andy@onthewings.net>  Thu, 02 Feb 2017 09:27:56 +0800
