=== debian/watch ===
version=3
opts="uversionmangle=s/-/~/g"\
 https://github.com/HaxeFoundation/haxe/releases .*/(\d\S*)\.tar\.gz
