=== debian/changelog ===
haxe (1:3.4.2-1ubuntu1) artful; urgency=medium

  * Drop dependencies on best/native ocaml compilers.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 08 Aug 2017 13:40:24 -0400

haxe (1:3.4.2-1) unstable; urgency=low

  * New upstream version.
  * Fix d/watch.

 -- Andy Li <andy@onthewings.net>  Thu, 23 Mar 2017 10:39:18 +0800
