=== debian/control ===
--- 
+++ 
@@ -1,14 +1,14 @@
 Source: haxe
 Section: devel
 Priority: optional
-Maintainer: Andy Li <andy@onthewings.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Andy Li <andy@onthewings.net>
 Standards-Version: 3.9.8
 Build-Depends: camlp4 (>= 3.11),
                debhelper (>= 9),
                libxml-light-ocaml-dev,
                neko (>= 2.0.0~),
                ocaml,
-               ocaml-best-compilers | ocaml-native-compilers,
                ocaml-findlib,
                zlib1g-dev,
                libpcre3-dev,
