=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for Haxe.

%:
	dh $@ --with bash-completion

PKD   = $(abspath $(dir $(MAKEFILE_LIST)))
PKG   = haxe
VER  = $(shell dpkg-parsechangelog -l$(PKD)/changelog | perl -ne 'print $$1 if m{^Version:\s+(?:\d+:)?(\d.*)(?:\-\d+.*)};')

override_dh_auto_configure:

override_dh_auto_build:
	# Check to see if ocamlopt exists. If not, bytecompile everything.
	command -v ocamlopt && dh_auto_build || dh_auto_build -- BYTECODE=1
	# Compile haxelib to neko
	dh_auto_build -- tools

override_dh_auto_install:

override_dh_strip:
	# haxelib is the neko vm appended with neko bytecode. It should not be stripped
	dh_strip --exclude=haxelib

get-orig-source:
	# create tar manually from git, in order to get submodules
	git clone --branch $(VER) --depth 1 --recursive https://github.com/HaxeFoundation/haxe.git orig-source
	cd orig-source && \
		python $(CURDIR)/debian/git-archive-all ../../$(PKG)_$(VER)$(DTYPE).orig.tar.gz
	rm -rf orig-source
