=== debian/changelog ===
haxe (1:3.4.4-2) unstable; urgency=low

  * Use dh_ocaml for ocamlopt detection.
  * Remove redundant ocaml-best-compilers, ocaml-native-compilers depends.
  * Add dh_missing.
  * Add autopkgtest support.

 -- Andy Li <andy@onthewings.net>  Tue, 21 Nov 2017 15:30:27 +0800

haxe (1:3.4.4-1) unstable; urgency=medium

  * New upstream version.
    + Fix flash target broken when compiled with OCaml 4.05.
  * Bump Standards-Version to 4.1.1 (no changes).
  * Update d/rules to use /usr/share/dpkg/pkg-info.mk to get source version.
  * Update d/watch to use the GitHub latest release page to avoid getting
    pre-release version.

 -- Andy Li <andy@onthewings.net>  Mon, 09 Oct 2017 09:50:21 +0800

haxe (1:3.4.3-1) unstable; urgency=low

  * New upstream version.
  * Remove hardening-* lintian overrides.
  * Bump Standards-Version to 4.1.0 (no changes).

 -- Andy Li <andy@onthewings.net>  Mon, 25 Sep 2017 13:38:07 +0800
