=== debian/control ===
--- 
+++ 
@@ -1,15 +1,15 @@
 Source: haxe
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Andy Li <andy@onthewings.net>
-Standards-Version: 3.9.8
-Build-Depends: camlp4 (>= 3.11),
-               debhelper (>= 9),
+Maintainer: Andy Li <andy@onthewings.net>
+Standards-Version: 4.1.1
+Build-Depends: debhelper (>= 9),
+               dh-ocaml,
+               ocaml-nox,
+               ocaml-findlib,
+               camlp4 (>= 3.11),
                libxml-light-ocaml-dev,
                neko (>= 2.0.0~),
-               ocaml,
-               ocaml-findlib,
                zlib1g-dev,
                libpcre3-dev,
                bash-completion
