=== debian/watch ===
version=3
opts="uversionmangle=s/-/~/g"\
 https://github.com/HaxeFoundation/haxe/releases/latest .*/archive/(\d\S*)\.tar\.gz
