## haxe 4.0.2

=== debian/changelog ===
haxe (1:4.0.2-1) unstable; urgency=medium

  * New upstream version.

 -- Andy Li <andy@onthewings.net>  Tue, 12 Nov 2019 12:37:34 +0800

haxe (1:4.0.1-1) unstable; urgency=medium

  * New upstream version.
    + Safe-strings compatible (Closes: #939961).
  * Remove camlp5.diff, which is no longer needed.
  * Bump Standards-Version to 4.4.1 (no changes).

 -- Andy Li <andy@onthewings.net>  Sun, 10 Nov 2019 21:25:41 +0800
